﻿Imports MusicListView
''' <summary>
''' FirstSongのGUI
''' </summary>
''' <remarks></remarks>
Public Class FirstSongGui

    Friend Class vis
        Public Enum DISP_TYPE
            WAVE
            POWER
            CIRCLE
            NON
        End Enum
        Public Enum VIS_TYPE
            Sky
            IndiamInk
            Electricity
            FLOWER
            Crystal
            Vortex
            AfterImage
            RANDOM
            USER
            [Image]
        End Enum
        Public Structure ColorRange
            Public LowColor As Color
            Public HiColor As Color
        End Structure
        Public Structure ChannelColor
            Public AutoColor As Boolean
            Public [Color] As Color
            Public Range As ColorRange
        End Structure
        Public Structure VisPrm
            Public LchColor As ChannelColor
            Public RchColor As ChannelColor
            Public BackColor As ChannelColor
            Public [Type] As vis.DISP_TYPE
            Public Size As Integer
            Public Alpha As Integer
            Public Smoke As Boolean
            Public SmokeSpeed As Integer
            Public Rotate As Boolean
            Public RotateSpeed As Integer
        End Structure
        Public Shared Function GetParam(ByVal t As VIS_TYPE) As VisPrm
            Dim p As VisPrm = New VisPrm
            Select Case t
                Case VIS_TYPE.IndiamInk
                    With p
                        .BackColor.Color = System.Drawing.Color.FromArgb(255, 255, 255)
                        .LchColor.Color = System.Drawing.Color.FromArgb(16, 0, 0)
                        .RchColor.Color = System.Drawing.Color.FromArgb(0, 0, 16)
                        .Type = vis.DISP_TYPE.POWER
                        .Size = 100
                        .Alpha = 64
                        .Smoke = False
                        .Rotate = False
                        .SmokeSpeed = 0
                        .RotateSpeed = 0
                        .LchColor.AutoColor = False
                        .RchColor.AutoColor = False
                        .BackColor.AutoColor = False
                    End With
                Case VIS_TYPE.Sky
                    With p
                        .BackColor.Color = System.Drawing.Color.FromArgb(127, 127, 255)
                        .LchColor.Color = System.Drawing.Color.FromArgb(255, 255, 255)
                        .RchColor.Color = System.Drawing.Color.FromArgb(255, 255, 255)
                        .Type = vis.DISP_TYPE.WAVE
                        .Size = 40
                        .Alpha = 24
                        .Smoke = True
                        .Rotate = True
                        .SmokeSpeed = 97
                        .RotateSpeed = 2
                        .LchColor.AutoColor = False
                        .RchColor.AutoColor = False
                        .BackColor.AutoColor = False
                    End With
                Case VIS_TYPE.Electricity
                    With p
                        .BackColor.Color = System.Drawing.Color.FromArgb(0, 0, 0)
                        .LchColor.Color = System.Drawing.Color.FromArgb(127, 255, 0)
                        .RchColor.Color = System.Drawing.Color.FromArgb(0, 255, 255)
                        .Type = vis.DISP_TYPE.WAVE
                        .Size = 80
                        .Alpha = 4
                        .Smoke = False
                        .Rotate = False
                        .SmokeSpeed = 0
                        .RotateSpeed = 0
                        .LchColor.AutoColor = False
                        .BackColor.AutoColor = False
                        .RchColor.AutoColor = False
                    End With
                Case VIS_TYPE.AfterImage
                    With p
                        .BackColor.Color = System.Drawing.Color.FromArgb(0, 0, 0)
                        .RchColor.Color = System.Drawing.Color.FromArgb(255, 255, 255)
                        .LchColor.Color = System.Drawing.Color.FromArgb(255, 255, 255)
                        .Type = vis.DISP_TYPE.POWER
                        .Size = 34
                        .Alpha = 142
                        .Smoke = True
                        .Rotate = True
                        .SmokeSpeed = 33
                        .RotateSpeed = 330
                        .LchColor.AutoColor = True
                        .BackColor.AutoColor = False
                        .RchColor.AutoColor = True
                        .RchColor.Range.LowColor = System.Drawing.Color.FromArgb(250, 127, 127)
                        .RchColor.Range.HiColor = System.Drawing.Color.FromArgb(250, 250, 250)
                        .LchColor.Range.LowColor = System.Drawing.Color.FromArgb(127, 127, 250)
                        .LchColor.Range.HiColor = System.Drawing.Color.FromArgb(250, 250, 250)
                    End With
                Case VIS_TYPE.FLOWER
                    With p
                        .BackColor.Color = System.Drawing.Color.FromArgb(32, 0, 0)
                        .LchColor.Color = System.Drawing.Color.FromArgb(255, 174, 201)
                        .RchColor.Color = System.Drawing.Color.FromArgb(255, 201, 201)
                        .Type = vis.DISP_TYPE.CIRCLE
                        .Size = 35
                        .Alpha = 48
                        .Smoke = True
                        .Rotate = True
                        .SmokeSpeed = 96
                        .RotateSpeed = 90
                        .LchColor.AutoColor = False
                        .RchColor.AutoColor = False
                        .BackColor.AutoColor = False
                    End With
                Case VIS_TYPE.Crystal
                    With p
                        .BackColor.Color = System.Drawing.Color.FromArgb(0, 0, 0)
                        .LchColor.Color = System.Drawing.Color.FromArgb(255, 255, 255)
                        .RchColor.Color = System.Drawing.Color.FromArgb(223, 223, 223)
                        .Type = vis.DISP_TYPE.CIRCLE
                        .Size = 41
                        .Alpha = 16
                        .Smoke = False
                        .Rotate = True
                        .SmokeSpeed = 0
                        .RotateSpeed = 358
                        .LchColor.AutoColor = False
                        .RchColor.AutoColor = True
                        .BackColor.AutoColor = False
                        .RchColor.Range.LowColor = System.Drawing.Color.FromArgb(216, 216, 216)
                        .RchColor.Range.HiColor = System.Drawing.Color.FromArgb(250, 250, 250)
                    End With
                Case VIS_TYPE.Vortex
                    With p
                        .BackColor.Color = System.Drawing.Color.FromArgb(0, 0, 0)
                        .LchColor.Color = System.Drawing.Color.FromArgb(0, 0, 0)
                        .RchColor.Color = System.Drawing.Color.FromArgb(128, 128, 128)
                        .Type = vis.DISP_TYPE.CIRCLE
                        .Size = 15
                        .Alpha = 3
                        .Smoke = True
                        .Rotate = True
                        .SmokeSpeed = 90
                        .RotateSpeed = 7
                        .LchColor.AutoColor = True
                        .RchColor.AutoColor = False
                        .BackColor.AutoColor = False
                        .LchColor.Range.LowColor = System.Drawing.Color.FromArgb(0, 0, 0)
                        .LchColor.Range.HiColor = System.Drawing.Color.FromArgb(16, 16, 16)
                    End With
                Case VIS_TYPE.RANDOM
                    '
                Case VIS_TYPE.Image
                    p.Type = DISP_TYPE.NON
            End Select
            Return p
        End Function
    End Class

    Private Structure MOUSE_STRUCT
        Public LeftButton As Boolean
        Public RightButton As Boolean
        Public x As Integer
        Public y As Integer
        Public blank_x As Integer
        Public blank_y As Integer
    End Structure

    Private Const GET_SAMPLE_COUNT As Integer = 8192

    Private utl As ConvenientLib.FontUtl

    Private pPlayFlag As Boolean = False
    Private Flag_Pos As Boolean
    Private pIndex As Integer
    Private pX As Integer
    Private pY As Integer
    Private pp As Integer
    Private pWS As System.Windows.Forms.FormWindowState
    Private pPath As String
    Private pPlaySubitem As System.Windows.Forms.ListViewItem
    Private pFont As System.Drawing.Font
    Private pFontColor As System.Drawing.Color
    Private Upchk As Integer = 15
    Private Dnchk As Integer = 2
    Private pWaveBackColor As System.Drawing.Color = Color.Black
    Private pWaveLch As System.Drawing.Color = Color.Red
    Private pWaveRch As System.Drawing.Color = Color.Blue
    Private pWaveAlpha As Integer = 64
    Private pSoftPeak As Integer = 0
    Private pLchAutoColor As Color = Color.White
    Private pRchAutoColor As Color = Color.White
    Private pLchAutoColorFlag As Boolean = False
    Private pRchAutoColorFlag As Boolean = False
    Private pBackAutoColorFlag As Boolean = False
    Private pRangeColorBack As vis.ColorRange
    Private pRangeColorLch As vis.ColorRange
    Private pRangeColorRch As vis.ColorRange
    Private pBackColor As Color = Color.Black
    Private pSize As Integer = 65
    Private pRand As Random
    Private pSampleCount As Integer = 2048
    Private pVisType As vis.VIS_TYPE = vis.VIS_TYPE.IndiamInk
    Private pDisp As vis.DISP_TYPE
    Private pSmoke As Boolean = True
    Private pRotate As Boolean = False
    Private pSmSpeed As Integer = 0
    Private pRtSpeed As Integer = 0
    Private pi As Double = 3.1415 / 180
    Private pGesture As MOUSE_STRUCT
    Private pImage As Image = Nothing

    ''' <summary>
    ''' 初期化関数
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub New()

        ' この呼び出しはデザイナーで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。
        Me.Visible = False

        'DPI変更時に対応するため、SplitContainerの位置を調整する
        Dim n As Integer
        Dim m As Integer
        n = mnuFS.Height - mnuFS.Top + spcMain.Margin.Top
        m = spcMain.Top - n
        spcMain.Top -= m
        spcMain.Height += m

        '初期化
        utl = New ConvenientLib.FontUtl
        pX = 0
        pY = 0
        pp = -1
        pFont = New System.Drawing.Font("標準ゴシック", 9)
        pFontColor = System.Drawing.SystemColors.WindowText
        pRand = New Random()
        With pGesture
            .LeftButton = False
            .RightButton = False
            .blank_x = 16
            .blank_y = 16
        End With

        '設定ファイルの内容をロード
        Call LoadConfig()
        pWS = Me.WindowState
        Flag_Pos = True

        '演奏エンジンの初期化
        mlsFiles.SampleCount = GET_SAMPLE_COUNT
        mlsFiles.EnginInit()

        '波形描画用イメージ準備
        picWave.Image = New Bitmap(picWave.Width, picWave.Height)

    End Sub

    Private Sub mlsFiles_Listup(ByVal FileCount As Integer) Handles mlsFiles.Listup
        'mlsFiles.Refresh()
    End Sub

    ''' <summary>
    ''' MusicListのPlayingイベント（演奏中に呼ばれるイベント(約 0.5秒間隔で呼ばれます)）
    ''' </summary>
    ''' <param name="Length">全体長</param>
    ''' <param name="Position">演奏位置</param>
    ''' <remarks>
    ''' 1.プログレスバーの更新を行う
    ''' 2.演奏が完了(Length = Position)なら次曲の再生
    ''' </remarks>
    Private Sub mlsFiles_Playing(ByVal Length As ULong, ByVal Position As ULong) Handles mlsFiles.Playing
        pPlayFlag = True
        'カーソルがバーの上になければ、現在の演奏位置に更新する
        If Flag_Pos Then
            If Length < 1 Then Length = 1
            prgPos.Value = ((Position / Length) * 1000)
            '最後まで演奏していたら、次の曲を演奏する
            If Position = Length Then
                If mnuPlayList.Checked Then
                    pIndex += 1
                End If

                If pIndex > mlsFiles.Items.Count - 1 Then
                    If mnuPlayLoop.Checked Then
                        If mlsFiles.Items.Count = 0 Then
                            pIndex = -1
                            Exit Sub
                        Else
                            pIndex = 0
                        End If
                    Else
                        Exit Sub
                    End If
                Else
                    If mnuPlayOne.Checked Then
                        If Not mnuPlayLoop.Checked Then
                            Exit Sub
                        End If
                    End If
                End If
                mlsFiles.PlayIndex(pIndex)
            End If
        End If
    End Sub

    ''' <summary>
    ''' 演奏開始で呼ばれるイベント
    ''' </summary>
    ''' <param name="File">演奏開始したファイル名</param>
    ''' <param name="Index">演奏開始したItemのIndex番号</param>
    ''' <remarks>タイトルバーに曲名を、ステータスバーにファイル名を設定する</remarks>
    Private Sub mlsFiles_PlsyStart(ByVal File As String, ByVal AlubmArt As BitMap, ByVal Index As Integer) Handles mlsFiles.PlsyStart
        Me.Text = mlsFiles.Items(Index).SubItems(1).Text & " - FirstSong"
        Me.stsPlayFile.Text = File
        pIndex = Index
        pPlaySubitem = mlsFiles.Items(Index)
        If (Not AlubmArt Is Nothing) Then
            pImage = AlubmArt.Clone()
        Else
            pImage = New Bitmap(picWave.Width, picWave.Height)
        End If
        picInfo.Refresh()
    End Sub

    ''' <summary>
    ''' 演奏情報表示
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks>現在演奏中の曲データをMusicList.Itemから取得し描画する</remarks>
    Private Sub DrawInfo(ByRef e As System.Windows.Forms.PaintEventArgs)
        Dim g As System.Drawing.Graphics
        Dim b As System.Drawing.Brush
        Dim p As System.Drawing.Point
        Dim strBuf As String

        If pPlaySubitem Is Nothing Then
            Exit Sub
        End If

        g = e.Graphics
        g.Clear(picInfo.BackColor)
        b = New System.Drawing.SolidBrush(pFontColor)
        p = New System.Drawing.Point(2, 2)
        strBuf = "< Title  > : " & pPlaySubitem.SubItems(1).Text & Environment.NewLine
        strBuf = strBuf & "< Artist > : " & pPlaySubitem.SubItems(2).Text & Environment.NewLine
        strBuf = strBuf & "< Alubm  > : " & pPlaySubitem.SubItems(3).Text & Environment.NewLine
        strBuf = strBuf & "< Year   > : " & pPlaySubitem.SubItems(4).Text
        g.DrawString(strBuf, pFont, b, p)
        b.Dispose()

    End Sub

    ''' <summary>
    ''' メニュー「設定」クリック
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>メニューのファイル－設定をクリックした場合、設定ダイアログを表示する</remarks>
    Private Sub CustomToolStripMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CustomToolStripMenuItem.Click
        Using ConfigWindow As ConfigDialog = New ConfigDialog
            With ConfigWindow
                '設定ダイアログに現在の状態を反映
                .txtFilePattern.Text = mlsFiles.FilePattern
                .dispFont.ListSetting.ForeColor = mlsFiles.ForeColor
                .dispFont.ListSetting.BackColor = mlsFiles.BackColor
                .dispFont.ListSetting.FontName = mlsFiles.Font.FontFamily.Name
                .dispFont.ListSetting.FontSize = mlsFiles.Font.Size
                .dispFont.TreeSetting.ForeColor = ctfFolder.ForeColor
                .dispFont.TreeSetting.BackColor = ctfFolder.BackColor
                .dispFont.TreeSetting.FontName = ctfFolder.Font.FontFamily.Name
                .dispFont.TreeSetting.FontSize = ctfFolder.Font.Size
                .dispFont.TreeSetting.UnderLine = ctfFolder.Font.Underline
                .dispFont.InfoSetting.FontName = pFont.FontFamily.Name
                .dispFont.InfoSetting.FontSize = pFont.Size
                .dispFont.InfoSetting.ForeColor = pFontColor
                .dispFont.InfoSetting.BackColor = picInfo.BackColor
                .cmbSample.Text = pSampleCount
                .chkLocal.Checked = mlsFiles.LocalMode
                .txtLocalDir.Text = mlsFiles.LocalDir
                .nudMSec.Value = mlsFiles.AdjustTime
                .rbnIndianink.Checked = False
                .rbnSky.Checked = False
                .rbnFlower.Checked = False
                .rbnCrystal.Checked = False
                Select Case pVisType
                    Case vis.VIS_TYPE.IndiamInk
                        .rbnIndianink.Checked = True
                    Case vis.VIS_TYPE.Sky
                        .rbnSky.Checked = True
                    Case vis.VIS_TYPE.Electricity
                        .rbnElectricity.Checked = True
                    Case vis.VIS_TYPE.FLOWER
                        .rbnFlower.Checked = True
                    Case vis.VIS_TYPE.Crystal
                        .rbnCrystal.Checked = True
                    Case vis.VIS_TYPE.Vortex
                        .rbnVortex.Checked = True
                    Case vis.VIS_TYPE.AfterImage
                        .rbnAfterImage.Checked = True
                    Case vis.VIS_TYPE.RANDOM
                        .rbnRandom.Checked = True
                    Case vis.VIS_TYPE.Image
                        .rbnAlbumArt.Checked = True
                End Select
                .nudDispCount.Value = mlsFiles.DisplayCount
                .chkShowChildDir.Checked = mlsFiles.ShowChildDirectory
                'ダイアログを表示
                .ShowDialog()
                'OKボタンが押されたら、内容を反映する
                If .DialogResult = System.Windows.Forms.DialogResult.OK Then
                    mlsFiles.ForeColor = .dispFont.ListSetting.ForeColor
                    mlsFiles.BackColor = .dispFont.ListSetting.BackColor
                    mlsFiles.Font = utl.MakeFont(.dispFont.ListSetting.FontName, .dispFont.ListSetting.FontSize)
                    mlsFiles.FilePattern = .txtFilePattern.Text
                    ctfFolder.ForeColor = .dispFont.TreeSetting.ForeColor
                    ctfFolder.BackColor = .dispFont.TreeSetting.BackColor
                    If .dispFont.TreeSetting.UnderLine Then
                        ctfFolder.Font = utl.MakeFont(.dispFont.TreeSetting.FontName, .dispFont.TreeSetting.FontSize, FontStyle.Underline)
                    Else
                        ctfFolder.Font = utl.MakeFont(.dispFont.TreeSetting.FontName, .dispFont.TreeSetting.FontSize)
                    End If
                    pFont = utl.MakeFont(.dispFont.InfoSetting.FontName, .dispFont.InfoSetting.FontSize)
                    pFontColor = .dispFont.InfoSetting.ForeColor
                    picInfo.BackColor = .dispFont.InfoSetting.BackColor
                    picInfo.Refresh()
                    pSampleCount = .cmbSample.Text
                    mlsFiles.LocalMode = .chkLocal.Checked
                    mlsFiles.LocalDir = .txtLocalDir.Text
                    mlsFiles.AdjustTime = .nudMSec.Value
                    If .rbnIndianink.Checked Then
                        pVisType = vis.VIS_TYPE.IndiamInk
                    End If
                    If .rbnSky.Checked Then
                        pVisType = vis.VIS_TYPE.Sky
                    End If
                    If .rbnElectricity.Checked Then
                        pVisType = vis.VIS_TYPE.Electricity
                    End If
                    If .rbnFlower.Checked Then
                        pVisType = vis.VIS_TYPE.FLOWER
                    End If
                    If .rbnCrystal.Checked Then
                        pVisType = vis.VIS_TYPE.Crystal
                    End If
                    If .rbnVortex.Checked Then
                        pVisType = vis.VIS_TYPE.Vortex
                    End If
                    If .rbnAfterImage.Checked Then
                        pVisType = vis.VIS_TYPE.AfterImage
                    End If
                    If .rbnRandom.Checked Then
                        pVisType = vis.VIS_TYPE.RANDOM
                    End If
                    If .rbnAlbumArt.Checked Then
                        pVisType = vis.VIS_TYPE.Image
                    End If
                    Call setVisPrm(pVisType)
                    mlsFiles.DisplayCount = .nudDispCount.Value
                    mlsFiles.ShowChildDirectory = .chkShowChildDir.Checked
                End If
            End With
        End Using
    End Sub

    Private Sub setVisPrm(ByVal t As vis.VIS_TYPE)
        Dim prm As vis.VisPrm = New vis.VisPrm
        prm = vis.GetParam(t)
        If t = vis.VIS_TYPE.RANDOM Then
            pLchAutoColorFlag = True
            pRchAutoColorFlag = True
            pBackAutoColorFlag = True
            pRangeColorLch.HiColor = System.Drawing.Color.FromArgb(255, 255, 255)
            pRangeColorLch.LowColor = System.Drawing.Color.FromArgb(128, 128, 128)
            pRangeColorRch.HiColor = System.Drawing.Color.FromArgb(255, 255, 255)
            pRangeColorRch.LowColor = System.Drawing.Color.FromArgb(128, 128, 128)
            pRangeColorBack.HiColor = System.Drawing.Color.FromArgb(64, 64, 64)
            pRangeColorBack.LowColor = System.Drawing.Color.FromArgb(0, 0, 0)
            pLchAutoColor = System.Drawing.Color.White
            pRchAutoColor = System.Drawing.Color.White
            pBackColor = System.Drawing.Color.Black
            pWaveAlpha -= Me.pRand.Next(0, 4)
            If pWaveAlpha < 4 Then pWaveAlpha = 128
            pSize += Me.pRand.Next(0, 10)
            If pSize > 100 Then pSize = 10
            If pRand.Next(1, 6) = 1 Then
                If pDisp = vis.DISP_TYPE.CIRCLE Then
                    pDisp = vis.DISP_TYPE.WAVE
                Else
                    pDisp = vis.DISP_TYPE.CIRCLE
                End If
            End If
            If pRand.Next(1, 6) = 1 Then
                pSmoke = Not pSmoke
                pSmSpeed = pRand.Next(10, 40)
            End If
            If pRand.Next(1, 6) = 1 Then
                pRotate = Not pRotate
                pRtSpeed = pRand.Next(1, 10)
            End If
            tTimer.Start()
        Else
            tTimer.Stop()
            pWaveBackColor = prm.BackColor.Color
            pWaveLch = prm.LchColor.Color
            pWaveRch = prm.RchColor.Color
            pWaveAlpha = prm.Alpha
            pSize = prm.Size
            pDisp = prm.Type
            pSmoke = prm.Smoke
            pSmSpeed = prm.SmokeSpeed
            pRotate = prm.Rotate
            pRtSpeed = prm.RotateSpeed
            pLchAutoColorFlag = prm.LchColor.AutoColor
            pRchAutoColorFlag = prm.RchColor.AutoColor
            pBackAutoColorFlag = prm.BackColor.AutoColor
            pRangeColorLch = prm.LchColor.Range
            pRangeColorRch = prm.RchColor.Range
            pRangeColorBack = prm.BackColor.Range
            pLchAutoColor = prm.LchColor.Range.HiColor
            pRchAutoColor = prm.RchColor.Range.HiColor
            pBackColor = prm.BackColor.Range.HiColor
        End If
    End Sub

    Private Sub FolderOpenToolStripMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles FolderOpenToolStripMenuItem.Click
        mlsFiles.OpenFolder()
    End Sub

    Private Sub AddFolderAToolStripMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AddFolderAToolStripMenuItem.Click
        Dim dialog As System.Windows.Forms.FolderBrowserDialog
        dialog = New System.Windows.Forms.FolderBrowserDialog
        dialog.RootFolder = System.Environment.SpecialFolder.MyComputer
        dialog.SelectedPath = mlsFiles.Path
        If dialog.ShowDialog = System.Windows.Forms.DialogResult.OK Then
            mlsFiles.AddPath(dialog.SelectedPath)
        End If
    End Sub

    Private Sub OpenPlayListToolStripMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles OpenPlayListToolStripMenuItem.Click
        mlsFiles.OpenPlayList()
    End Sub

    'Treeのフォルダを選択すると呼ばれる
    Private Sub ctfFolder_FolderSelected(ByVal Path As String) Handles ctfFolder.FolderSelected
        Me.Cursor = Cursors.WaitCursor
        Try
            pPath = Path
            mlsFiles.Path = Path
        Catch ex As Exception
        End Try
        Me.Cursor = Cursors.Default
    End Sub

    'Treeのプレイリストが選択されると呼ばれる
    Private Sub ctfFolder_VirtualFolderSelected(ByVal Path As String) Handles ctfFolder.VirtualFolderSelected
        Me.Cursor = Cursors.WaitCursor
        pPath = Path
        mlsFiles.PlayList = Path
        Me.Cursor = Cursors.Default
    End Sub

    'INIファイルのロード
    Private Sub LoadConfig()
        Dim ir As IniFile.Reader
        Dim inifile As String

        'INIファイルのパスを決定
        'inifile = Application.UserAppDataPath
        inifile = System.Environment.GetFolderPath(
                            Environment.SpecialFolder.ApplicationData) _
                                & "\" & Application.ProductName
        If Not inifile.Last() = "\" Then
            inifile = inifile & "\"
        End If
        inifile = inifile & "FirstSong.ini"

        Dim v As String, v2 As String
        Dim i As Integer
        Dim x As Integer, y As Integer

        ir = New IniFile.Reader(inifile)

        x = ir.ReadInteger("WindowState", "X")
        If ir.GetResault Then
            y = ir.ReadInteger("WindowState", "Y")
            If ir.GetResault Then
                Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
                Me.DesktopLocation = New System.Drawing.Point(x, y)
            End If
        End If

        i = ir.ReadInteger("WindowState", "Width")
        If ir.GetResault Then
            Me.Width = i
        End If
        i = ir.ReadInteger("WindowState", "Height")
        If ir.GetResault Then
            Me.Height = i
        End If

        i = ir.ReadInteger("WindowState", "Split_X")
        If ir.GetResault Then
            spcExploer.SplitterDistance = i
        End If

        i = ir.ReadInteger("WindowState", "Split_Y")
        If ir.GetResault Then
            spcMain.SplitterDistance = i
        End If

        i = ir.ReadInteger("List", "TRACK")
        If ir.GetResault Then
            mlsFiles.Columns.Item(0).Width = i
        End If
        i = ir.ReadInteger("List", "TITLE")
        If ir.GetResault Then
            mlsFiles.Columns.Item(1).Width = i
        End If
        i = ir.ReadInteger("List", "ARTIST")
        If ir.GetResault Then
            mlsFiles.Columns.Item(2).Width = i
        End If
        i = ir.ReadInteger("List", "ALBUM")
        If ir.GetResault Then
            mlsFiles.Columns.Item(3).Width = i
        End If
        i = ir.ReadInteger("List", "YEAR")
        If ir.GetResault Then
            mlsFiles.Columns.Item(4).Width = i
        End If
        i = ir.ReadInteger("List", "COMMENT")
        If ir.GetResault Then
            mlsFiles.Columns.Item(5).Width = i
        End If

        v = ir.Read("List", "Font")
        If ir.GetResault Then
            i = ir.ReadInteger("List", "FontSize")
            If ir.GetResault Then
                mlsFiles.Font = utl.MakeFont(v, i)
            End If
        End If
        i = ir.ReadInteger("List", "ForeColor")
        If ir.GetResault Then
            mlsFiles.ForeColor = System.Drawing.Color.FromArgb(i)
        End If
        i = ir.ReadInteger("List", "BackColor")
        If ir.GetResault Then
            mlsFiles.BackColor = System.Drawing.Color.FromArgb(i)
        End If
        v = ir.Read("List", "FilePattern")
        If ir.GetResault Then
            mlsFiles.FilePattern = v
        End If

        i = ir.ReadInteger("List", "DisplayCount")
        If ir.GetResault Then
            mlsFiles.DisplayCount = i
        End If
        v = ir.Read("List", "ShowChildDir")
        If ir.GetResault Then
            If v = "True" Then
                mlsFiles.ShowChildDirectory = True
            Else
                mlsFiles.ShowChildDirectory = False
            End If
        End If

        v = ir.Read("Tree", "Font")
        If ir.GetResault Then
            i = ir.ReadInteger("Tree", "FontSize")
            If ir.GetResault Then
                v2 = ir.Read("Tree", "UnderLine")
                If v2 = "True" Then
                    ctfFolder.Font = utl.MakeFont(v, i, FontStyle.Underline)
                Else
                    ctfFolder.Font = utl.MakeFont(v, i)
                End If
            End If
        End If
        i = ir.ReadInteger("Tree", "ForeColor")
        If ir.GetResault Then
            ctfFolder.ForeColor = System.Drawing.Color.FromArgb(i)
        End If
        i = ir.ReadInteger("Tree", "BackColor")
        If ir.GetResault Then
            ctfFolder.BackColor = System.Drawing.Color.FromArgb(i)
        End If

        v = ir.Read("Info", "Font")
        If ir.GetResault Then
            i = ir.ReadInteger("Info", "FontSize")
            If ir.GetResault Then
                pFont = utl.MakeFont(v, i)
            End If
        End If
        i = ir.ReadInteger("Info", "ForeColor")
        If ir.GetResault Then
            pFontColor = System.Drawing.Color.FromArgb(i)
        End If
        i = ir.ReadInteger("Info", "BackColor")
        If ir.GetResault Then
            picInfo.BackColor = System.Drawing.Color.FromArgb(i)
        End If

        v = ir.Read("Display", "vis")
        If ir.GetResault Then
            Select Case v
                Case vis.VIS_TYPE.IndiamInk.ToString
                    pVisType = vis.VIS_TYPE.IndiamInk
                Case vis.VIS_TYPE.Sky.ToString
                    pVisType = vis.VIS_TYPE.Sky
                Case vis.VIS_TYPE.Electricity.ToString
                    pVisType = vis.VIS_TYPE.Electricity
                Case vis.VIS_TYPE.FLOWER.ToString
                    pVisType = vis.VIS_TYPE.FLOWER
                Case vis.VIS_TYPE.Crystal.ToString
                    pVisType = vis.VIS_TYPE.Crystal
                Case vis.VIS_TYPE.Vortex.ToString
                    pVisType = vis.VIS_TYPE.Vortex
                Case vis.VIS_TYPE.AfterImage.ToString
                    pVisType = vis.VIS_TYPE.AfterImage
                Case vis.VIS_TYPE.RANDOM.ToString
                    pVisType = vis.VIS_TYPE.RANDOM
                Case vis.VIS_TYPE.Image.ToString
                    pVisType = vis.VIS_TYPE.Image
            End Select
        End If
        Call setVisPrm(pVisType)

        i = ir.ReadInteger("Wave", "SampleCount")
        If ir.GetResault Then
            pSampleCount = i
        End If
        'i = ir.ReadInteger("Wave", "BackColor")
        'If ir.GetResault Then
        '    pWaveBackColor = System.Drawing.Color.FromArgb(i)
        'End If
        'i = ir.ReadInteger("Wave", "LchColor")
        'If ir.GetResault Then
        '    pWaveLch = System.Drawing.Color.FromArgb(i)
        'End If
        'i = ir.ReadInteger("Wave", "RchColor")
        'If ir.GetResault Then
        '    pWaveRch = System.Drawing.Color.FromArgb(i)
        'End If
        'i = ir.ReadInteger("Wave", "Alpha")
        'If ir.GetResault Then
        '    pWaveAlpha = i
        'End If
        'v = ir.Read("Wave", "RandomColor")
        'If ir.GetResault Then
        '    If v = "True" Then
        '        pAutoColor = True
        '    End If
        'End If
        'v = ir.Read("Wave", "Smoke")
        'If ir.GetResault Then
        '    If v = "True" Then
        '        pSmoke = True
        '    End If
        'End If
        i = ir.ReadInteger("Wave", "adjust")
        If ir.GetResault Then
            mlsFiles.AdjustTime = i
        End If

        'v = ir.Read("Engine", "Lib")
        'If ir.GetResault Then
        '    Select Case True
        '        Case (v = MusicList.EngineType.BASS.ToString)
        '            mlsFiles.Engine = MusicList.EngineType.BASS
        '        Case (v = MusicList.EngineType.DirectShow.ToString)
        '            mlsFiles.Engine = MusicList.EngineType.DirectShow
        '    End Select
        'End If

        v = ir.Read("Engine", "Free")
        If ir.GetResault Then
            If v = "True" Then
                mlsFiles.GCControl = True
            Else
                mlsFiles.GCControl = False
            End If
        End If

        v = ir.Read("Tree", "Path")
        If ir.GetResault Then
            pPath = v
        Else
            pPath = "C:\"
        End If

        v = ir.Read("WindowState", "State")
        Select Case True
            Case (v = System.Windows.Forms.FormWindowState.Maximized.ToString)
                Me.WindowState = System.Windows.Forms.FormWindowState.Maximized
            Case (v = System.Windows.Forms.FormWindowState.Minimized.ToString)
                Me.WindowState = System.Windows.Forms.FormWindowState.Minimized
            Case Else
                Me.WindowState = System.Windows.Forms.FormWindowState.Normal
        End Select

        v = ir.Read("Play", "One")
        If ir.GetResault Then
            If v = "True" Then
                mnuPlayOne.Checked = True
                mnuPlayList.Checked = False
            End If
        End If

        v = ir.Read("Play", "List")
        If ir.GetResault Then
            If v = "True" Then
                mnuPlayOne.Checked = False
                mnuPlayList.Checked = True
            End If
        End If

        v = ir.Read("Play", "Loop")
        If ir.GetResault Then
            If v = "True" Then
                mnuPlayLoop.Checked = True
            Else
                mnuPlayLoop.Checked = False
            End If
        End If

        v = ir.Read("Play", "Local")
        If ir.GetResault Then
            If v = "True" Then
                mlsFiles.LocalMode = True
            Else
                mlsFiles.LocalMode = False
            End If
        End If
        v = ir.Read("Play", "LocalDir")
        If ir.GetResault Then
            mlsFiles.LocalDir = v
        End If

    End Sub

    Private Sub FirstSongGui_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        Dim iw As IniFile.Writer
        Dim inifile As String

        Try
            mlsFiles.PlayStop()
            'inifile = Application.UserAppDataPath
            inifile = System.Environment.GetFolderPath(
                                Environment.SpecialFolder.ApplicationData) _
                                    & "\" & Application.ProductName
            If System.IO.Directory.Exists(inifile) = False Then
                System.IO.Directory.CreateDirectory(inifile)
            End If
            If Not inifile.Last() = "\" Then
                inifile = inifile & "\"
            End If
            inifile = inifile & "FirstSong.ini"

            iw = New IniFile.Writer(inifile)
            iw.Wait = 20

            If iw.Write("WindowState", "State", Me.WindowState.ToString) = False Then
                System.Windows.Forms.MessageBox.Show("INI FILE WRITE ERR")
            End If
            Me.Visible = False
            If (Me.WindowState <> System.Windows.Forms.FormWindowState.Normal) Then
                Me.WindowState = System.Windows.Forms.FormWindowState.Normal
                System.Windows.Forms.Application.DoEvents()
            End If
            iw.Write("WindowState", "X", Me.Location.X.ToString)
            iw.Write("WindowState", "Y", Me.Location.Y.ToString)
            iw.Write("WindowState", "Width", Me.Width.ToString)
            iw.Write("WindowState", "Height", Me.Height.ToString)
            iw.Write("WindowState", "Split_X", spcExploer.SplitterDistance.ToString)
            iw.Write("WindowState", "Split_Y", spcMain.SplitterDistance.ToString)

            iw.Write("List", "TRACK", mlsFiles.Columns.Item(0).Width.ToString)
            iw.Write("List", "TITLE", mlsFiles.Columns.Item(1).Width.ToString)
            iw.Write("List", "ARTIST", mlsFiles.Columns.Item(2).Width.ToString)
            iw.Write("List", "ALBUM", mlsFiles.Columns.Item(3).Width.ToString)
            iw.Write("List", "YEAR", mlsFiles.Columns.Item(4).Width.ToString)
            iw.Write("List", "COMMENT", mlsFiles.Columns.Item(5).Width.ToString)

            iw.Write("List", "Font", mlsFiles.Font.Name)
            iw.Write("List", "FontSize", mlsFiles.Font.Size.ToString)
            iw.Write("List", "ForeColor", mlsFiles.ForeColor.ToArgb.ToString)
            iw.Write("List", "BackColor", mlsFiles.BackColor.ToArgb.ToString)
            iw.Write("List", "FilePattern", mlsFiles.FilePattern)
            iw.Write("List", "DisplayCount", mlsFiles.DisplayCount)
            iw.Write("List", "ShowChildDir", mlsFiles.ShowChildDirectory.ToString)

            iw.Write("Tree", "Font", ctfFolder.Font.Name)
            iw.Write("Tree", "FontSize", ctfFolder.Font.Size.ToString)
            iw.Write("Tree", "UnderLine", ctfFolder.Font.Underline.ToString)
            iw.Write("Tree", "ForeColor", ctfFolder.ForeColor.ToArgb.ToString)
            iw.Write("Tree", "BackColor", ctfFolder.BackColor.ToArgb.ToString)

            iw.Write("Info", "Font", pFont.Name)
            iw.Write("Info", "FontSize", pFont.Size.ToString)
            iw.Write("Info", "ForeColor", pFontColor.ToArgb.ToString)
            iw.Write("Info", "BackColor", picInfo.BackColor.ToArgb.ToString)

            iw.Write("Display", "vis", pVisType.ToString)

            iw.Write("Wave", "SampleCount", pSampleCount)
            'iw.Write("Wave", "BackColor", pWaveBackColor.ToArgb.ToString)
            'iw.Write("Wave", "LchColor", pWaveLch.ToArgb.ToString)
            'iw.Write("Wave", "RchColor", pWaveRch.ToArgb.ToString)
            'iw.Write("Wave", "Alpha", pWaveAlpha.ToString)
            'iw.Write("Wave", "Smoke", pSmoke.ToString)

            iw.Write("Wave", "adjust", mlsFiles.AdjustTime.ToString)

            'iw.Write("Engine", "Lib", mlsFiles.Engine.ToString)

            iw.Write("Tree", "Path", pPath)

            iw.Write("Play", "One", mnuPlayOne.Checked.ToString)
            iw.Write("Play", "List", mnuPlayList.Checked.ToString)
            iw.Write("Play", "Loop", mnuPlayLoop.Checked.ToString)
            iw.Write("Play", "Local", mlsFiles.LocalMode.ToString)
            iw.Write("Play", "LocalDir", mlsFiles.LocalDir)

        Catch ex As Exception
            System.Windows.Forms.MessageBox.Show(ex.Message)
        End Try

    End Sub

    Private Sub prgPos_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles prgPos.MouseUp
        Dim newPos As ULong
        newPos = (mlsFiles.Length * (prgPos.Value / prgPos.Maximum))
        mlsFiles.Position = newPos
    End Sub

    Private Sub prgPos_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles prgPos.MouseLeave
        Flag_Pos = True
    End Sub

    Private Sub prgPos_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles prgPos.MouseMove
        Flag_Pos = False
        pp = (e.X / prgPos.Width) * (prgPos.Maximum - prgPos.Minimum)
        prgPos.Value = pp
    End Sub

    Private Sub FirstSongGui_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            ctfFolder.Create(pPath)
        Catch ex As Exception

        End Try
    End Sub

    Private Sub picInfo_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picInfo.MouseDown
        pGesture.LeftButton = False
        pGesture.RightButton = False
        If e.Button = Windows.Forms.MouseButtons.Left Then
            pGesture.LeftButton = True
            pGesture.x = e.X
            pGesture.y = e.Y
        End If
        If e.Button = Windows.Forms.MouseButtons.Right Then
            pGesture.RightButton = True
            pGesture.x = e.X
            pGesture.y = e.Y
        End If
    End Sub

    Private Sub picInfo_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picInfo.MouseUp
        If e.Button = Windows.Forms.MouseButtons.Left Then
            If pGesture.LeftButton Then
                If e.X < (pGesture.x + pGesture.blank_x) And e.X > (pGesture.x - pGesture.blank_x) Then
                    pGesture.LeftButton = False
                    If pPlayFlag Then
                        mlsFiles.Pause()
                        pPlayFlag = False
                    Else
                        mlsFiles.Resume()
                    End If
                    Exit Sub
                End If
                If e.X > pGesture.x Then
                    mlsFiles.PlayNext()
                    pGesture.LeftButton = False
                End If
                If e.X < pGesture.x Then
                    pIndex = pIndex - 1
                    If pIndex < 0 Then pIndex = mlsFiles.Items.Count - 1
                    mlsFiles.PlayIndex(pIndex)
                    pGesture.LeftButton = False
                End If
            End If
        End If
    End Sub

    Private Sub picInfo_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picInfo.Paint
        DrawInfo(e)
    End Sub

    Private Sub mnuPlayOne_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuPlayOne.Click
        mnuPlayOne.Checked = Not mnuPlayOne.Checked
        mnuPlayList.Checked = Not mnuPlayList.Checked
    End Sub

    Private Sub mnuPlayList_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuPlayList.Click
        mnuPlayOne.Checked = Not mnuPlayOne.Checked
        mnuPlayList.Checked = Not mnuPlayList.Checked
    End Sub

    Private Sub mnuPlayNext_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuPlayNext.Click
        If mlsFiles.Items.Count = -1 Then
            Exit Sub
        End If
        mlsFiles.PlayStop()
        pIndex += 1
        If pIndex > (mlsFiles.Items.Count - 1) Then
            pIndex = 0
        End If
        mlsFiles.PlayIndex(pIndex)
    End Sub

    Private Sub mnuPlayBack_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuPlayBack.Click
        If mlsFiles.Items.Count = -1 Then
            Exit Sub
        End If
        mlsFiles.PlayStop()
        pIndex -= 1
        If pIndex < 0 Then
            pIndex = mlsFiles.Items.Count - 1
        End If
        mlsFiles.PlayIndex(pIndex)
    End Sub

    Private Sub spcMain_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles spcMain.Resize
        picWave.Width = spcMain.Panel2.ClientSize.Height - picWave.Top
        picWave.Height = picWave.Width
        picInfo.Left = picWave.Left + picWave.Width + picInfo.Margin.Left
        picInfo.Width = spcMain.Panel2.Width - picWave.Width - picWave.Margin.Left - picWave.Margin.Right - picInfo.Margin.Left - picInfo.Margin.Right
        picInfo.Height = spcMain.Panel2.ClientSize.Height - picInfo.Top
        If pVisType = vis.VIS_TYPE.Image Then Return
        '波形描画用イメージ準備
        picWave.Image = New Bitmap(picWave.Width, picWave.Height)
    End Sub
    Private Sub spcMain_SplitterMoved(ByVal sender As Object, ByVal e As System.Windows.Forms.SplitterEventArgs) Handles spcMain.SplitterMoved
        picWave.Width = spcMain.Panel2.ClientSize.Height - picWave.Top
        picWave.Height = picWave.Width
        picInfo.Left = picWave.Left + picWave.Width + picInfo.Margin.Left
        picInfo.Width = spcMain.Panel2.Width - picWave.Width - picWave.Margin.Left - picWave.Margin.Right - picInfo.Margin.Left - picInfo.Margin.Right
        picInfo.Height = spcMain.Panel2.ClientSize.Height - picInfo.Top
        If pVisType = vis.VIS_TYPE.Image Then Return
        '波形描画用イメージ準備
        picWave.Image = New Bitmap(picWave.Width, picWave.Height)
    End Sub

    Private Sub FirstSongGui_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        LoadConfig()
    End Sub

    Private Sub mnuVer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuVer.Click
        Dim ver As System.Diagnostics.FileVersionInfo = System.Diagnostics.FileVersionInfo.GetVersionInfo(
                                                                                System.Reflection.Assembly.GetExecutingAssembly().Location)
        Dim sb As String
        sb = My.Application.Info.ProductName &
                    " Ver." & ver.FileVersion.ToString & vbCrLf &
                    "( build " & My.Application.Info.Version.Revision & " )"
        System.Windows.Forms.MessageBox.Show(sb)
    End Sub

    Private Sub mlsFiles_WaveDataChange(ByRef WaveData() As Integer) Handles mlsFiles.WaveDataChange
        Dim DrawRect As Rectangle = picWave.ClientRectangle
        Dim g As Graphics = Graphics.FromImage(picWave.Image)

        If pBackAutoColorFlag Then
            If pBackColor.ToArgb = pWaveBackColor.ToArgb Then
                pBackColor = Color.FromArgb(pRand.Next(pRangeColorBack.LowColor.R, pRangeColorBack.HiColor.R),
                                            pRand.Next(pRangeColorBack.LowColor.G, pRangeColorBack.HiColor.G),
                                            pRand.Next(pRangeColorBack.LowColor.B, pRangeColorBack.HiColor.B))
            Else
                pWaveBackColor = NewColor(pWaveBackColor, pBackColor)
            End If
        End If
        If pLchAutoColorFlag Then
            If pLchAutoColor.ToArgb = pWaveLch.ToArgb Then
                pLchAutoColor = Color.FromArgb(pRand.Next(pRangeColorLch.LowColor.R, pRangeColorLch.HiColor.R),
                                            pRand.Next(pRangeColorLch.LowColor.G, pRangeColorLch.HiColor.G),
                                            pRand.Next(pRangeColorLch.LowColor.B, pRangeColorLch.HiColor.B))
            Else
                pWaveLch = NewColor(pWaveLch, pLchAutoColor)
            End If
        End If
        If pRchAutoColorFlag Then
            If pRchAutoColor.ToArgb = pWaveRch.ToArgb Then
                pRchAutoColor = Color.FromArgb(pRand.Next(pRangeColorRch.LowColor.R, pRangeColorRch.HiColor.R),
                                            pRand.Next(pRangeColorRch.LowColor.G, pRangeColorRch.HiColor.G),
                                            pRand.Next(pRangeColorRch.LowColor.B, pRangeColorRch.HiColor.B))
            Else
                pWaveRch = NewColor(pWaveRch, pRchAutoColor)
            End If
        End If

        Dim p1 As System.Drawing.Pen = New Pen(pWaveLch)
        Dim p2 As System.Drawing.Pen = New Pen(pWaveRch)
        If pSmoke OrElse pRotate Then
            Dim bmp As New Bitmap(picWave.Image)
            If pRotate Then
                bmp = RotateBitmap(bmp, pRtSpeed, DrawRect.Width / 2, DrawRect.Height / 2)
            End If
            If pSmoke Then
                Dim sx As Integer, sy As Integer
                sx = DrawRect.Width / 100 * (100 - pSmSpeed)
                sy = DrawRect.Height / 100 * (100 - pSmSpeed)
                Dim rectSrc As New Rectangle(sx, sy, DrawRect.Width - 2 * sx, DrawRect.Height - 2 * sy)
                g.DrawImage(bmp, DrawRect, rectSrc, GraphicsUnit.Pixel)
            Else
                g.DrawImage(bmp, DrawRect)
            End If
            bmp.Dispose()
        End If
        g.FillRectangle(New SolidBrush(Color.FromArgb(pWaveAlpha, pWaveBackColor)), DrawRect)

        '描画
        Select Case pDisp
            Case vis.DISP_TYPE.WAVE
                Dim h0 As Integer = DrawRect.Height \ 3
                Dim h1 As Integer = (DrawRect.Height \ 3) * 2
                Dim y0 As Integer
                Dim yy0 As Integer = h0
                Dim x0 As Integer = 0
                Dim xx0 As Integer = 0
                Dim y1 As Integer
                Dim yy1 As Integer = h1
                Dim x1 As Integer = 0
                Dim xx1 As Integer = 0
                Dim Count As Integer = pSampleCount
                Dim AddCount As Integer = mlsFiles.SampleCount / pSampleCount
                Dim i As Integer = 0
                Dim LchFlag As Boolean = True
                Debug.Print(WaveData(i))
                yy0 = CInt(h0 * WaveData(i) / 32767 + h0)
                yy1 = CInt(h0 * WaveData(i + 1) / 32767 + h1)
                For n As Integer = 1 To Count - 1 Step AddCount
                    x0 = CInt((DrawRect.Width / Count) * (n + 1))
                    y0 = CInt(((h0 * WaveData(i) / 32767) * (pSize / 100)) + h0)
                    x1 = CInt((DrawRect.Width / Count) * (n + 1))
                    y1 = CInt(((h0 * WaveData(i + 1) / 32767) * (pSize / 100)) + h1)
                    i += AddCount * 2
                    If LchFlag Then
                        g.DrawLine(p1, xx0, yy0, x0, y0)
                        g.DrawLine(p2, xx1, yy1, x1, y1)
                    Else
                        g.DrawLine(p2, xx1, yy1, x1, y1)
                        g.DrawLine(p1, xx0, yy0, x0, y0)
                    End If
                    xx0 = x0
                    yy0 = y0
                    xx1 = x1
                    yy1 = y1
                    LchFlag = Not LchFlag
                Next
            Case vis.DISP_TYPE.POWER
                Dim v As Integer = DrawRect.Height / 31 * 15
                Dim h0 As Integer = DrawRect.Height / 31 * 15
                Dim h1 As Integer = DrawRect.Height / 31 * 16
                Dim y0 As Integer
                Dim x As Integer
                Dim y1 As Integer
                Dim Count As Integer = pSampleCount
                Dim AddCount As Integer = mlsFiles.SampleCount / pSampleCount
                Dim i As Integer = 0
                For n As Integer = 0 To Count - 1 Step AddCount
                    x = CInt((DrawRect.Width / Count) * (n + 1))
                    If WaveData(i) > 0 Then
                        y0 = (h0 - ((WaveData(i))) / 32767 * (v * (pSize / 100)))
                    Else
                        y0 = (h0 + ((WaveData(i))) / 32767 * (v * (pSize / 100)))
                    End If
                    If WaveData(i + 1) > 0 Then
                        y1 = (h1 + ((WaveData(i + 1))) / 32767 * (v * (pSize / 100)))
                    Else
                        y1 = (h1 - ((WaveData(i + 1))) / 32767 * (v * (pSize / 100)))
                    End If
                    i += AddCount * 2
                    g.DrawLine(p1, x, h0, x, y0)
                    g.DrawLine(p2, x, h1, x, y1)
                Next
            Case vis.DISP_TYPE.CIRCLE
                Dim x As Integer = DrawRect.Width / 2
                Dim y As Integer = DrawRect.Height / 2
                Dim r As Integer = DrawRect.Height / 10
                Dim h As Integer = DrawRect.Height
                Dim v As Integer
                Dim xa0 As Integer, xa1 As Integer
                Dim ya0 As Integer, ya1 As Integer
                Dim xb0 As Integer, xb1 As Integer
                Dim yb0 As Integer, yb1 As Integer
                Dim bCh As Boolean = False
                Dim Count As Integer = pSampleCount
                Dim AddCount As Integer = mlsFiles.SampleCount / pSampleCount
                Dim i As Integer
                Dim n As Integer
                Dim radian As Double = Math.PI / 180
                For n = 0 To Count - 1 Step AddCount
                    v = WaveData(i) / 32767 * h * (pSize / 100)
                    xa1 = System.Math.Sin(radian * (360 * n / pSampleCount * 4)) * (r + v) + x
                    ya1 = System.Math.Cos(radian * (360 * n / pSampleCount * 4)) * (r + v) + y
                    v = WaveData(i + 1) / 32767 * h * (pSize / 100)
                    xb1 = System.Math.Sin(radian * (360 * n / pSampleCount * 4)) * (r + v) + x
                    yb1 = System.Math.Cos(radian * (360 * n / pSampleCount * 4)) * (r + v) + y
                    If n > 0 Then
                        If bCh Then
                            g.DrawLine(p1, xa0, ya0, xa1, ya1)
                            g.DrawLine(p2, xb0, yb0, xb1, yb1)
                        Else
                            g.DrawLine(p2, xb0, yb0, xb1, yb1)
                            g.DrawLine(p1, xa0, ya0, xa1, ya1)
                        End If
                    End If
                    xa0 = xa1
                    ya0 = ya1
                    xb0 = xb1
                    yb0 = yb1
                    i += AddCount * 2
                Next
        End Select
        p1.Dispose()
        p2.Dispose()
        picWave.Refresh()
    End Sub
    Private Function RotateBitmap(ByVal bmp As Bitmap, ByVal angle As Single, ByVal x As Integer, ByVal y As Integer) As Bitmap

        Dim bmp2 As Bitmap = New Bitmap(bmp.Width, bmp.Height)
        Dim g As Graphics = Graphics.FromImage(bmp2)
        g.Clear(pWaveBackColor)

        g.TranslateTransform(-x, -y)
        g.RotateTransform(angle, System.Drawing.Drawing2D.MatrixOrder.Append)
        g.TranslateTransform(x, y, System.Drawing.Drawing2D.MatrixOrder.Append)

        g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBilinear

        g.DrawImageUnscaled(bmp, 0, 0)
        g.Dispose()

        Return bmp2
    End Function

    Private Function NewColor(ByVal srcColor As Color, ByVal CompareColor As Color) As Color
        Dim r As Integer, g As Integer, b As Integer
        r = srcColor.R
        g = srcColor.G
        b = srcColor.B
        If srcColor.R < CompareColor.R Then
            r += 1
        ElseIf srcColor.R > CompareColor.R Then
            r -= 1
        End If
        If srcColor.G < CompareColor.G Then
            g += 1
        ElseIf srcColor.G > CompareColor.G Then
            g -= 1
        End If
        If srcColor.B < CompareColor.B Then
            b += 1
        ElseIf srcColor.B > CompareColor.B Then
            b -= 1
        End If
        Return Color.FromArgb(r, g, b)
    End Function

    Private Sub picWave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picWave.Click
        Select Case pVisType
            Case vis.VIS_TYPE.IndiamInk
                pVisType = vis.VIS_TYPE.Sky
            Case vis.VIS_TYPE.Sky
                pVisType = vis.VIS_TYPE.Electricity
            Case vis.VIS_TYPE.Electricity
                pVisType = vis.VIS_TYPE.FLOWER
            Case vis.VIS_TYPE.FLOWER
                pVisType = vis.VIS_TYPE.Crystal
            Case vis.VIS_TYPE.Crystal
                pVisType = vis.VIS_TYPE.Vortex
            Case vis.VIS_TYPE.Vortex
                pVisType = vis.VIS_TYPE.AfterImage
            Case vis.VIS_TYPE.AfterImage
                pVisType = vis.VIS_TYPE.RANDOM
            Case vis.VIS_TYPE.RANDOM
                pVisType = vis.VIS_TYPE.Image
            Case vis.VIS_TYPE.Image
                pVisType = vis.VIS_TYPE.IndiamInk
        End Select
        setVisPrm(pVisType)
    End Sub

    Private Sub tTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tTimer.Tick
        If pVisType <> vis.VIS_TYPE.RANDOM Then
            tTimer.Stop()
            Return
        End If
        tTimer.Interval = pRand.Next(1000, 10000)
        setVisPrm(pVisType)
    End Sub

    Private Sub mlsFiles_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mlsFiles.SelectedIndexChanged

    End Sub

    Private Sub picWave_Paint(sender As Object, e As PaintEventArgs) Handles picWave.Paint
        If pVisType = vis.VIS_TYPE.Image AndAlso (Not pImage Is Nothing) Then
            Dim g As Graphics = e.Graphics
            g.InterpolationMode = Drawing2D.InterpolationMode.HighQualityBilinear
            Dim x As Integer, y As Integer, w As Integer, h As Integer
            If pImage.Width = pImage.Height Then
                x = 0
                y = 0
                w = picWave.Width
                h = picWave.Height
            Else
                If pImage.Width > pImage.Height Then
                    x = 0
                    w = picWave.Width
                    h = pImage.Height / pImage.Width * picWave.Height
                    y = picWave.Height - h
                    y /= 2
                Else
                    y = 0
                    h = picWave.Height
                    w = pImage.Width / pImage.Height * picWave.Width
                    x = picWave.Width - w
                    x /= 2
                End If
            End If
            g.Clear(Color.Black)
            g.DrawImage(pImage, x, y, w, h)
        End If
    End Sub
End Class